#include <sta/bus/interface.hpp>

#include <sta/debug/assert.hpp>

namespace sta
{
    Interface::Interface(Mutex * mutex)
        : mutex_{mutex}, acquired_{false}
    {
        STA_ASSERT(mutex != nullptr);
    }

    void Interface::acquire()
    {
        mutex_->acquire();
        acquired_ = true;
    }

    void Interface::release()
    {
        acquired_ = false;
        mutex_->release();
    }

    bool Interface::isAcquired()
    {
        return acquired_;
    }
} // namespace sta
